package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateRouterLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUpdateRouterLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateRouterLogic {
	return &UpdateRouterLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdateRouterLogic) UpdateRouter(req *types.UpdateRouterReq) (resp *types.UpdateRouterResp, err error) {
	// todo: add your logic here and delete this line
	UpdateRouterReq := &openstack.UpdateRouterReq{}
	err = copier.CopyWithOption(UpdateRouterReq, req, copier.Option{Converters: utils.Converters})
	UpdateRouterResp, err := l.svcCtx.OpenstackRpc.UpdateRouter(l.ctx, UpdateRouterReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UpdateRouterResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UpdateRouterResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
